#include "../include/rational.hpp"
#include "../include/division.hpp"

CDivision::CDivision( CPrintable *a, CPrintable *b ) : COperator(a, b) {}
CRational *CDivision::evaluate() {
    std::unique_ptr<CRational> a (m_firstArgument->evaluate());
    std::unique_ptr<CRational> b (m_secondArgument->evaluate());
    if (b->m_numerator->isZero())
        throw std::logic_error("division by zero");
    return a->div(b.get());
}