#include "../include/rational.hpp"
#include "../include/logarithm.hpp"

CLogarith::CLogarith( CPrintable *a, CPrintable *b ) : COperator(a, b) {}
CRational *CLogarith::evaluate() {
    std::unique_ptr<CRational> a (m_firstArgument->evaluate());
    std::unique_ptr<CRational> b (m_secondArgument->evaluate());
    if (a->m_numerator->isZero()) { // base zero -> neturtal log
        return b->ln();
    }
    if (a->isNegative() || b->isNegative())
        throw std::logic_error("logarith on negative numbers");

    a.reset(a->ln());
    b.reset(b->ln());

    return b->div(a.get());
}