#include "../include/rational.hpp"
#include "../include/modulo.hpp"

CModulo::CModulo( CPrintable *a, CPrintable *b ) : COperator(a, b) {}
CRational *CModulo::evaluate() {
    std::unique_ptr<CRational> a (m_firstArgument->evaluate());
    std::unique_ptr<CRational> b (m_secondArgument->evaluate());
    CBigInt one(1);
    if (a->m_denominator.get()->cmp(&one) || b->m_denominator.get()->cmp(&one))
        throw "mod on racional not supported";
    return new CRational( a->m_numerator.get()->mod(b->m_numerator.get()));
}