#pragma once
#include "rational.hpp"
#include "operator.hpp"

/**
 * @class CDivision
 * @brief The CDivision class represents the division operator.
 * It inherits from the COperator class.
 */
class CDivision : public COperator {
public:
    /**
     * @brief Constructor for CDivision class.
     * @param a The numerator of the division operation.
     * @param b The denominator of the division operation.
     */
    CDivision( CPrintable *a, CPrintable *b );

    /**
     * @brief Default constructor for CDivision class.
     */
    CDivision() = default;

    /**
     * @brief Destructor for CDivision class.
     */
    ~CDivision() = default;

    /**
     * @brief Evaluates the division operation.
     * @return A CRational pointer representing the result of the division.
     */
    virtual CRational *evaluate() override;
private:
};
