#pragma once
#include "rational.hpp"
#include "operator.hpp"

/**
 * @brief The CLogarith class represents a logarithm operation.
 * It inherits from the COperator class.
 */
class CLogarith : public COperator {
public:
    /**
     * @brief Constructor for CLogarith class.
     * @param a The base of the logarithm operation.
     * @param b The argument of the logarithm operation.
     */
    CLogarith( CPrintable *a, CPrintable *b );

    /**
     * @brief Default constructor for CLogarith class.
     */
    CLogarith() = default;

    /**
     * @brief Destructor for CLogarith class.
     */
    ~CLogarith() = default;

    /**
     * @brief Evaluates the logarithm operation.
     * @return A CRational pointer representing the result of the logarithm operation.
     */
    virtual CRational *evaluate() override;
private:
};
