#pragma once
#include "rational.hpp"
#include "operator.hpp"

/**
 * @brief The CMultiplication class represents a multiplication operation.
 * It inherits from the COperator class.
 */
class CMultiplication : public COperator {
public:
    /**
     * @brief Constructor for CMultiplication class.
     * @param a The first argument of the multiplication operation.
     * @param b The second argument of the multiplication operation.
     */
    CMultiplication( CPrintable *a, CPrintable *b );

    /**
     * @brief Default constructor for CMultiplication class.
     */
    CMultiplication() = default;

    /**
     * @brief Destructor for CMultiplication class.
     */
    ~CMultiplication() = default;

    /**
     * @brief Evaluates the multiplication operation.
     * @return A CRational pointer representing the result of the multiplication operation.
     */
    virtual CRational *evaluate() override;

private:
};

