#pragma once
#include "rational.hpp"
#include "operator.hpp"

/**
 * @brief The CSubtraction class represents the subtraction operator.
 */
class CSubtraction : public COperator {
public:
    /**
     * @brief Constructor for CSubtraction class.
     * @param a The first argument of the subtraction.
     * @param b The second argument of the subtraction.
     */
    CSubtraction(CPrintable *a, CPrintable *b);

    /**
     * @brief Default constructor for CSubtraction class.
     */
    CSubtraction() = default;

    /**
     * @brief Default destructor for CSubtraction class.
     */
    ~CSubtraction() = default;

    /**
     * @brief Evaluates the subtraction operation.
     * @return A CRational pointer representing the evaluated result.
     */
    virtual CRational *evaluate() override;
private:
};

